<script>
    import { slide } from 'svelte/transition'
    import { sineOut } from 'svelte/easing'

    export let name
    export let label
    export let errors
</script>

<label for={name}>{label}</label>
<div class="form-control">
    <slot />
</div>
{#if errors?.length}
    <ul class="error" transition:slide={{ duration: 100, easing: sineOut }}>
        {#each errors as error}
            <li>{error}</li>
        {/each}
    </ul>
{/if}

<style lang="postcss">
    label {
        @apply col-start-1 col-span-1 px-4 py-2 font-medium bg-white;

        &:not(:first-of-type) {
            @apply border-t;
        }
    }

    .form-control {
        @apply flex flex-col items-start justify-between col-start-2 col-span-1 pr-4 py-2 bg-white;

        &:not(:first-of-type) {
            @apply border-t;
        }
    }

    .error {
        @apply relative col-span-full bg-red-500 px-4 py-2 text-red-50 text-center font-medium;

        &::before {
            @apply absolute block left-1/2 -top-1 h-2 w-2 bg-red-500 transform rotate-45 -translate-x-1/2;
            content: '';
        }
    }
</style>
